function RBH_AddBounty(name,amount,faction,realm,zone,class,split,lock,seq)   
   
    if RBH_HitList == nil then 
       RBH_HitList={};
    end
   
    if name == nil then
       return
    end    
      
    local player
	local realm
	player, realm = UnitFullName("player")
	player = player.."-"..realm
	
    local timestamp = time()
    
    --create time based unique id
    local timeID = timestamp - 1200000000
    
    --create global to enforce uniqueness
    if RBH_LastBountyId == nil then
        RBH_LastBountyId = 0
    end
    
    --test for temporal anomolies
    if timeID == RBH_LastBountyId then
        timeID = timeID + 1
    end
    
    --append the player's name
    local id = player.."_"..timeID
    
    local state = "RBH_OPEN"
    local claimer = ""
    local issuer = player
    local xcoord,ycoord,intelage,guild
    local audit = 0
    local gsc;
   
    if seq ~= nil then
        id = id..seq
    end
   
    --handle special bounty options
    if split == nil and lock == nil then
        state = "RBH_OPEN"
    elseif split and lock then
        state = "RBH_OPEN_SL"
    elseif split then
        state = "RBH_OPEN_S"
    elseif lock then
        state = "RBH_OPEN_L"
    end 
   
    --handle cross realm names
    local n1,n2,destName,destRealm = string.find(name,"(.+)-(.+)")
    if destName == nil then
        destName = name
        destRealm = GetRealmName()
    end 
   
    if UnitName("target") == destName then
        faction = UnitFactionGroup("target")
        name,realm = UnitName("target")
        level = UnitLevel("target")
        race = UnitRace("target")
        class = UnitClass("target")    
        zone = GetRealZoneText("player")
        xcoord,ycoord = GetPlayerMapPosition("player");
        xcoord = floor(xcoord*100)
        ycoord = floor(ycoord*100)
        intelage = time()
        guild = GetGuildInfo("target");
    else
        if faction == nil then
            faction = UnitFactionGroup(name)      
        end
    end   
    if faction == nil then
        faction = "UNKNOWN"
    end
    if realm == nil then
        realm = GetRealmName()
    end
    if zone == nil then
        zone = ""
    end   
    if xcoord == nil then
        xcoord = 0
    end
    if ycoord == nil then
        ycoord = 0
    end
    if intelage == nil then
        intelage = 0
    end
    if class == nil then
        class = ""
    end
    if race == nil then
        race = ""
    end
    if level == nil then
        level = ""
    end
    if guild == nil then
        guild = ""
    end
    
    local realmChannel
    if RBH_Config["RealmChannel"] then
        realmChannel = RBH_REALM_CHANNEL
    else
        realmChannel = ""
    end
        
    local guildChannel
    if RBH_Config["GuildChannel"] then
        guildChannel = GetGuildInfo("player")
    else
        guildChannel = ""
    end
    
    local privateChannel
    if RBH_Config["PrivateChannel"] then
        privateChannel = RBH_PRIVATE_CHANNEL
    else
        privateChannel = ""
    end   
   
    RBH_Msg("[RBH] Bounty placed on "..name.." for "..RBH_CopperToGold(amount))      
    local msg = id..","..timestamp..","..name..","..issuer..","..amount..","..claimer..","..state..","..audit..","..faction..","..realm..","..zone..","..xcoord..","..ycoord..","..intelage..","..class..","..race..","..level..","..guild..","..realmChannel..","..guildChannel..","..privateChannel
    table.insert(RBH_HitList,{id=id,name=name,amount=amount,issuer=player,timestamp=timestamp,state=state,claimer=claimer,audit=audit,faction=faction,realm=realm,zone=zone,xcoord=xcoord,ycoord=ycoord,intelage=intelage,class=class,race=race,level=level,guild=guild,realm_chan=realmChannel,guild_chan=guildChannel,private_chan=privateChannel});   
    --local msg = id..","..timestamp..","..name..","..issuer..","..amount..","..claimer..","..state..","..audit..","..faction..","..realm..","..zone..","..xcoord..","..ycoord..","..intelage
    RBH_Largess = RBH_Largess - amount
    RBH_HitListUpdate()
    RBH_SendAddonMessageToNetwork("BULK", "RBH_HL_UPDATE", msg) 
end

function RBH_DeleteBounty()    
    
    if RBH_SelectedBountyId == nil then
        return
    end
    
    local id = RBH_SelectedBountyId
    local i 
   
   for i = 1,#RBH_HitList do    
      if RBH_HitList[i].id == id then
        if RBH_HitList[i].issuer ~= RBH_GetFullName(UnitName("player")) then
            RBH_LargessMessage("You can only delete bounties that you have issued.", "red")
            return
         end
         RBH_HitList[i].state = "RBH_DEL"
         RBH_HitList[i].timestamp = time()
         local amount = RBH_HitList[i].amount
         RBH_Largess = RBH_Largess + amount
         RBH_HitListUpdate()
         local msg = RBH_BountyToString(i)
         RBH_SendAddonMessageToNetwork("ALERT","RBH_HL_UPDATE", msg);  
         
         -- increment GUI selection         
         if RBH_HitListFiltered[RBH_SelectedBounty] ~= nil then
            RBH_SelectedBountyId = RBH_HitListFiltered[RBH_SelectedBounty].id
         else
            RBH_SelectedBountyId = nil
         end
         
         return  --assumes unique ids
      end
   end  
 end
 
function RBH_AddBGBounties(amount,split,lock,seq)
   local n = GetNumBattlefieldScores()
   local i,name, killingBlows, honorableKills, deaths, honorGained, faction, rank, race, classToken, damageDone, healingDone 

   for i = 1,n do
      name,killingBlows,honorableKills,deaths,honorGained,faction, rank, race, classToken, damageDone, healingDone = GetBattlefieldScore(i)
      if (faction == 0 and RBH_PlayerFaction == "Alliance") or (faction == 1 and RBH_PlayerFaction == "Horde") then
         --handle cross realm names
         local n1,n2,destName,destRealm = string.find(name,"(.+)-(.+)")
         if destName == nil then
            destName = name
            destRealm = GetRealmName()
         end          
         RBH_AddBounty(destName,amount,RBH_EnemyFaction,destRealm,GetRealZoneText("player"),classToken,split,lock,seq)      
      end
   end
end

function RBH_CopperToGold(copper)
    local gp,sp,cp,gsp;    
    gp = floor(tonumber(copper)/10000);
    sp = abs(floor(mod(tonumber(copper),10000)/100));   
    cp = abs(mod(mod(tonumber(copper),10000),100));    
    gsp = tostring(gp).."g "..tostring(sp).."s "..tostring(cp).."c";
    return gsp;
end